// Copyright (c) 2022 Douglas Miller <durgadas311@gmail.com>
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class mttest implements ActionListener {
	private JFrame front_end;
	private DiskDrive[] drvs;
	private boolean[] mnts;

	public mttest(String[] args) {
		mnts = new boolean[8];
		drvs = new DiskDrive[8];
		front_end = new JFrame("Virtual Disk Drive");
		front_end.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		front_end.getContentPane().setBackground(new Color(100, 100, 100));
		GridBagConstraints gc = new GridBagConstraints();
		gc.fill = GridBagConstraints.NONE;
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0;
		gc.weighty = 0;
		gc.gridwidth = 1;
		gc.gridheight = 1;
		gc.insets.bottom = 0;
		gc.insets.top = 0;
		gc.insets.left = 0;
		gc.insets.right = 0;
		gc.anchor = GridBagConstraints.CENTER;
		GridBagLayout gb = new GridBagLayout();
		front_end.setLayout(gb);

		DiskDrive mtd;
		for (int x = 0; x < 8; ++x) {
			mtd = new DiskDrive(x);
			gb.setConstraints(mtd, gc);
			front_end.add(mtd);
			++gc.gridx;
			if (x == 3) {
				gc.gridx = 0;
				++gc.gridy;
				JPanel pn = new JPanel();
				pn.setPreferredSize(new Dimension(5, 5));
				pn.setOpaque(false);
				gb.setConstraints(pn, gc);
				front_end.add(pn);
				++gc.gridy;
			}
			mtd.a_Listener(this);
			mtd.b_Listener(this);
			mtd.fmtListener(this);
			mtd.datListener(this);
			mtd.packListener(this);
			drvs[x] = mtd;
		}

		front_end.pack();
		front_end.setVisible(true);

	}

	public static void main(String[] args) {
		new mttest(args);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof JButton) {
			JButton bt = (JButton)e.getSource();
			String act = bt.getActionCommand();
			int lun = act.charAt(1) - '0';
			int chr = act.charAt(0);
			if (chr == 'M') {
				mnts[lun] = !mnts[lun];
				if (mnts[lun]) {
					drvs[lun].setDisk("pack1");
					drvs[lun].setPos(0, 0);
				} else {
					drvs[lun].setDisk(null);
					drvs[lun].setA(false);
					drvs[lun].setB(false);
					drvs[lun].setFMT(false);
					drvs[lun].setDAT(false);
				}
			} else if (chr == 'F') {
				drvs[lun].setFMT(true);
			} else if (chr == 'D') {
				drvs[lun].setDAT(true);
			} else if (chr == 'A') {
				drvs[lun].setA(true);
			} else if (chr == 'B') {
				drvs[lun].setB(true);
			}
		}
	}
}
